# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_recognition_msgs/ICPAlignWithBoxRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import jsk_recognition_msgs.msg
import sensor_msgs.msg
import std_msgs.msg

class ICPAlignWithBoxRequest(genpy.Message):
  _md5sum = "9431a0df63f5a2625b973e92c6229cf3"
  _type = "jsk_recognition_msgs/ICPAlignWithBoxRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """sensor_msgs/PointCloud2 target_cloud
jsk_recognition_msgs/BoundingBox target_box

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: jsk_recognition_msgs/BoundingBox
# BoundingBox represents a oriented bounding box.
Header header
geometry_msgs/Pose pose
geometry_msgs/Vector3 dimensions  # size of bounding box (x, y, z)
# You can use this field to hold value such as likelihood
float32 value
uint32 label

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['target_cloud','target_box']
  _slot_types = ['sensor_msgs/PointCloud2','jsk_recognition_msgs/BoundingBox']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       target_cloud,target_box

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ICPAlignWithBoxRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.target_cloud is None:
        self.target_cloud = sensor_msgs.msg.PointCloud2()
      if self.target_box is None:
        self.target_box = jsk_recognition_msgs.msg.BoundingBox()
    else:
      self.target_cloud = sensor_msgs.msg.PointCloud2()
      self.target_box = jsk_recognition_msgs.msg.BoundingBox()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs))
      _x = self.target_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.target_cloud.height, _x.target_cloud.width))
      length = len(self.target_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.target_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step))
      _x = self.target_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B3I().pack(_x.target_cloud.is_dense, _x.target_box.header.seq, _x.target_box.header.stamp.secs, _x.target_box.header.stamp.nsecs))
      _x = self.target_box.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dfI().pack(_x.target_box.pose.position.x, _x.target_box.pose.position.y, _x.target_box.pose.position.z, _x.target_box.pose.orientation.x, _x.target_box.pose.orientation.y, _x.target_box.pose.orientation.z, _x.target_box.pose.orientation.w, _x.target_box.dimensions.x, _x.target_box.dimensions.y, _x.target_box.dimensions.z, _x.target_box.value, _x.target_box.label))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_cloud is None:
        self.target_cloud = sensor_msgs.msg.PointCloud2()
      if self.target_box is None:
        self.target_box = jsk_recognition_msgs.msg.BoundingBox()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.target_cloud.height, _x.target_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.target_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.target_cloud.is_bigendian = bool(self.target_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.target_cloud.is_dense, _x.target_box.header.seq, _x.target_box.header.stamp.secs, _x.target_box.header.stamp.nsecs,) = _get_struct_B3I().unpack(str[start:end])
      self.target_cloud.is_dense = bool(self.target_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_box.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_box.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 88
      (_x.target_box.pose.position.x, _x.target_box.pose.position.y, _x.target_box.pose.position.z, _x.target_box.pose.orientation.x, _x.target_box.pose.orientation.y, _x.target_box.pose.orientation.z, _x.target_box.pose.orientation.w, _x.target_box.dimensions.x, _x.target_box.dimensions.y, _x.target_box.dimensions.z, _x.target_box.value, _x.target_box.label,) = _get_struct_10dfI().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs))
      _x = self.target_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.target_cloud.height, _x.target_cloud.width))
      length = len(self.target_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.target_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step))
      _x = self.target_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B3I().pack(_x.target_cloud.is_dense, _x.target_box.header.seq, _x.target_box.header.stamp.secs, _x.target_box.header.stamp.nsecs))
      _x = self.target_box.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_10dfI().pack(_x.target_box.pose.position.x, _x.target_box.pose.position.y, _x.target_box.pose.position.z, _x.target_box.pose.orientation.x, _x.target_box.pose.orientation.y, _x.target_box.pose.orientation.z, _x.target_box.pose.orientation.w, _x.target_box.dimensions.x, _x.target_box.dimensions.y, _x.target_box.dimensions.z, _x.target_box.value, _x.target_box.label))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_cloud is None:
        self.target_cloud = sensor_msgs.msg.PointCloud2()
      if self.target_box is None:
        self.target_box = jsk_recognition_msgs.msg.BoundingBox()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.target_cloud.height, _x.target_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.target_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.target_cloud.is_bigendian = bool(self.target_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.target_cloud.is_dense, _x.target_box.header.seq, _x.target_box.header.stamp.secs, _x.target_box.header.stamp.nsecs,) = _get_struct_B3I().unpack(str[start:end])
      self.target_cloud.is_dense = bool(self.target_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_box.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_box.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 88
      (_x.target_box.pose.position.x, _x.target_box.pose.position.y, _x.target_box.pose.position.z, _x.target_box.pose.orientation.x, _x.target_box.pose.orientation.y, _x.target_box.pose.orientation.z, _x.target_box.pose.orientation.w, _x.target_box.dimensions.x, _x.target_box.dimensions.y, _x.target_box.dimensions.z, _x.target_box.value, _x.target_box.label,) = _get_struct_10dfI().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10dfI = None
def _get_struct_10dfI():
    global _struct_10dfI
    if _struct_10dfI is None:
        _struct_10dfI = struct.Struct("<10dfI")
    return _struct_10dfI
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_B2I = None
def _get_struct_B2I():
    global _struct_B2I
    if _struct_B2I is None:
        _struct_B2I = struct.Struct("<B2I")
    return _struct_B2I
_struct_B3I = None
def _get_struct_B3I():
    global _struct_B3I
    if _struct_B3I is None:
        _struct_B3I = struct.Struct("<B3I")
    return _struct_B3I
_struct_IBI = None
def _get_struct_IBI():
    global _struct_IBI
    if _struct_IBI is None:
        _struct_IBI = struct.Struct("<IBI")
    return _struct_IBI
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_recognition_msgs/ICPAlignWithBoxResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import jsk_recognition_msgs.msg
import std_msgs.msg

class ICPAlignWithBoxResponse(genpy.Message):
  _md5sum = "a511a876c2be142caffd78741c68e4cf"
  _type = "jsk_recognition_msgs/ICPAlignWithBoxResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """jsk_recognition_msgs/ICPResult result


================================================================================
MSG: jsk_recognition_msgs/ICPResult
Header header
geometry_msgs/Pose pose
string name
float64 score
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['result']
  _slot_types = ['jsk_recognition_msgs/ICPResult']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       result

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ICPAlignWithBoxResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.result is None:
        self.result = jsk_recognition_msgs.msg.ICPResult()
    else:
      self.result = jsk_recognition_msgs.msg.ICPResult()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.result.header.seq, _x.result.header.stamp.secs, _x.result.header.stamp.nsecs))
      _x = self.result.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.result.pose.position.x, _x.result.pose.position.y, _x.result.pose.position.z, _x.result.pose.orientation.x, _x.result.pose.orientation.y, _x.result.pose.orientation.z, _x.result.pose.orientation.w))
      _x = self.result.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.result.score
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.result is None:
        self.result = jsk_recognition_msgs.msg.ICPResult()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.result.header.seq, _x.result.header.stamp.secs, _x.result.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.result.pose.position.x, _x.result.pose.position.y, _x.result.pose.position.z, _x.result.pose.orientation.x, _x.result.pose.orientation.y, _x.result.pose.orientation.z, _x.result.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.name = str[start:end]
      start = end
      end += 8
      (self.result.score,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.result.header.seq, _x.result.header.stamp.secs, _x.result.header.stamp.nsecs))
      _x = self.result.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.result.pose.position.x, _x.result.pose.position.y, _x.result.pose.position.z, _x.result.pose.orientation.x, _x.result.pose.orientation.y, _x.result.pose.orientation.z, _x.result.pose.orientation.w))
      _x = self.result.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.result.score
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.result is None:
        self.result = jsk_recognition_msgs.msg.ICPResult()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.result.header.seq, _x.result.header.stamp.secs, _x.result.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.result.pose.position.x, _x.result.pose.position.y, _x.result.pose.position.z, _x.result.pose.orientation.x, _x.result.pose.orientation.y, _x.result.pose.orientation.z, _x.result.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.result.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.result.name = str[start:end]
      start = end
      end += 8
      (self.result.score,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
class ICPAlignWithBox(object):
  _type          = 'jsk_recognition_msgs/ICPAlignWithBox'
  _md5sum = 'd23c790c7c4a5f0e959eba05efc9d29a'
  _request_class  = ICPAlignWithBoxRequest
  _response_class = ICPAlignWithBoxResponse
